# -*- cperl -*-
#
# Rapi2::Defs
#
# This module provides access to the definitions of the rapi.h.
#
# AUTHOR: Andreas Pohl <osar@users.sourceforge.net>
#
# $Id: Defs.pm,v 1.2 2003/03/11 19:48:42 osar Exp $
package Rapi2::Defs;

use strict;

use vars qw($VERSION @ISA @EXPORT);
require Exporter;
@ISA = qw(Exporter);

use Rapi2;
$VERSION='0.02';

@EXPORT=qw[
	GENERIC_WRITE GENERIC_READ FILE_SHARE_READ CREATE_NEW CREATE_ALWAYS OPEN_EXISTING
	OPEN_ALWAYS TRUNCATE_EXISTING OPEN_FOR_LOADER FILE_ATTRIBUTE_READONLY
        FILE_ATTRIBUTE_HIDDEN FILE_ATTRIBUTE_SYSTEM FILE_ATTRIBUTE_1
        FILE_ATTRIBUTE_DIRECTORY FILE_ATTRIBUTE_ARCHIVE FILE_ATTRIBUTE_INROM
        FILE_ATTRIBUTE_NORMAL FILE_ATTRIBUTE_TEMPORARY FILE_ATTRIBUTE_2	FILE_ATTRIBUTE_3
	FILE_ATTRIBUTE_COMPRESSED FILE_ATTRIBUTE_ROMSTATICREF FILE_ATTRIBUTE_ROMMODULE
	FILE_ATTRIBUTE_4 FILE_ATTRIBUTE_5 FILE_ATTRIBUTE_HAS_CHILDREN
        FILE_ATTRIBUTE_SHORTCUT FILE_ATTRIBUTE_6 FILE_ATTRIBUTE_7 FAF_ATTRIBUTES
	FAF_CREATION_TIME FAF_LASTACCESS_TIME FAF_LASTWRITE_TIME FAF_SIZE_HIGH
        FAF_SIZE_LOW FAF_OID FAF_NAME FAF_ATTRIB_CHILDREN FAF_ATTRIB_NO_HIDDEN
	FAF_FOLDERS_ONLY FAF_NO_HIDDEN_SYS_ROMMODULES CSIDL_PROGRAMS CSIDL_PERSONAL
	CSIDL_FAVORITES_GRYPHON	CSIDL_STARTUP CSIDL_RECENT CSIDL_STARTMENU
        CSIDL_DESKTOPDIRECTORY CSIDL_FONTS CSIDL_FAVORITES CEDB_MAXDBASENAMELEN
	CEDB_MAXSORTORDER CEDB_VALIDNAME CEDB_VALIDTYPE CEDB_VALIDSORTSPEC
        CEDB_VALIDMODTIME CEDB_AUTOINCREMENT CEDB_NOCOMPRESS CEDB_SORT_DESCENDING
	CEDB_SORT_CASEINSENSITIVE CEDB_SORT_UNKNOWNFIRST CEDB_SORT_GENERICORDER
	CEDB_SEEK_CEOID CEDB_SEEK_BEGINNING CEDB_SEEK_END CEDB_SEEK_CURRENT
	CEDB_SEEK_VALUESMALLER CEDB_SEEK_VALUEFIRSTEQUAL CEDB_SEEK_VALUEGREATER
	CEDB_SEEK_VALUENEXTEQUAL CEDB_PROPNOTFOUND CEDB_PROPDELETE CEDB_MAXDATABLOCKSIZE
	CEDB_MAXPROPDATASIZE CEDB_MAXRECORDSIZE CEDB_ALLOWREALLOC CEVT_I2 CEVT_I4
        CEVT_R8 CEVT_BOOL CEVT_UI2 CEVT_UI4 CEVT_LPWSTR CEVT_FILETIME CEVT_BLOB
	CEVT_FLAG_EMPTY FAD_OID FAD_FLAGS FAD_NAME FAD_TYPE FAD_NUM_RECORDS
	FAD_NUM_SORT_ORDER FAD_SIZE FAD_LAST_MODIFIED FAD_SORT_SPECS HKEY_CLASSES_ROOT
	HKEY_CURRENT_USER HKEY_LOCAL_MACHINE HKEY_USERS REG_NONE REG_SZ REG_EXPAND_SZ
	REG_BINARY REG_DWORD REG_DWORD_LITTLE_ENDIAN REG_DWORD_BIG_ENDIAN REG_LINK
	REG_MULTI_SZ PROCESSOR_INTEL_386 PROCESSOR_INTEL_486 PROCESSOR_INTEL_PENTIUM
	PROCESSOR_INTEL_PENTIUMII PROCESSOR_MIPS_R4000 PROCESSOR_ALPHA_21064
	PROCESSOR_PPC_403 PROCESSOR_PPC_601 PROCESSOR_PPC_603 PROCESSOR_PPC_604
	PROCESSOR_PPC_620 PROCESSOR_HITACHI_SH3 PROCESSOR_HITACHI_SH3E
        PROCESSOR_HITACHI_SH4 PROCESSOR_MOTOROLA_821 PROCESSOR_SHx_SH3 PROCESSOR_SHx_SH4
	PROCESSOR_STRONGARM PROCESSOR_ARM720 PROCESSOR_ARM820 PROCESSOR_ARM920
	PROCESSOR_ARM_7TDMI PROCESSOR_ARCHITECTURE_INTEL PROCESSOR_ARCHITECTURE_MIPS
	PROCESSOR_ARCHITECTURE_ALPHA PROCESSOR_ARCHITECTURE_PPC
	PROCESSOR_ARCHITECTURE_SHX PROCESSOR_ARCHITECTURE_ARM
	PROCESSOR_ARCHITECTURE_IA64 PROCESSOR_ARCHITECTURE_ALPHA64
	PROCESSOR_ARCHITECTURE_UNKNOWN AC_LINE_OFFLINE AC_LINE_ONLINE
	AC_LINE_BACKUP_POWER AC_LINE_UNKNOWN BATTERY_FLAG_HIGH BATTERY_FLAG_LOW
	BATTERY_FLAG_CRITICAL BATTERY_FLAG_CHARGING BATTERY_FLAG_NO_BATTERY
	BATTERY_FLAG_UNKNOWN BATTERY_PERCENTAGE_UNKNOWN BATTERY_LIFE_UNKNOWN
	VER_PLATFORM_WIN32s VER_PLATFORM_WIN32_WINDOWS VER_PLATFORM_WIN32_NT
	VER_PLATFORM_WIN32_HH VER_PLATFORM_WIN32_CE OBJTYPE_INVALID OBJTYPE_FILE
	OBJTYPE_DIRECTORY OBJTYPE_DATABASE OBJTYPE_RECORD OBJTYPE_DELETED

	CE_TITLE CE_FIRST_NAME CE_TEL_OFFICE CE_TEL_PRIVAT CE_LAST_NAME CE_COMPANY
	CE_POSITION CE_DEPART CE_OFFICE CE_TEL_MOBIL CE_TEL_RADIO CE_TEL_CAR
	CE_FAX_OFFICE CE_FAX_PRIVAT CE_TEL_PRIVAT2 CE_BIRTHDAY CE_SEKRET
        CE_ANNYVERSARY CE_TEL_SEKRET CE_CHILDREN CE_TEL_OFFICE2 CE_WEBPAGE CE_PAGER
	CE_MATE CE_LAST_FIRST_NAME CE_SALUTATION CE_SEC_NAME CE_PRIVAT_STREET
	CE_PRIVAT_CITY CE_PRIVAT_REGION CE_PRIVAT_ZIP CE_PRIVAT_COUNTRY
	CE_OFFICE_STREET CE_OFFICE_CITY CE_OFFICE_REGION CE_OFFICE_ZIP
	CE_OFFICE_COUNTRY CE_ADD_STREET CE_ADD_CITY CE_ADD_REGION CE_ADD_ZIP
	CE_ADD_COUNTRY CE_EMAIL CE_EMAIL2 CE_EMAIL3 CE_CATEGORY CE_NOTE CE_CATPRIV
	CE_CATWORK

        E_ABORT E_ACCESSDENIED E_FAIL E_HANDLE E_INVALIDARG E_NOINTERFACE E_NOTIMPL
        E_OUTOFMEMORY E_PENDING E_POINTER E_UNEXPECTED S_FALSE S_OK ERROR_SUCCESS
        ERROR_FILE_NOT_FOUND ERROR_NOT_ENOUGH_MEMORY ERROR_SEEK ERROR_INVALID_PARAMETER
        ERROR_INSUFFICIENT_BUFFER ERROR_NO_DATA ERROR_NO_MORE_ITEMS ERROR_KEY_DELETED
        MAX_PATH
];


#
# File access functions
#

# dwShareMode
sub GENERIC_WRITE { 0x40000000 }
sub GENERIC_READ { 0x80000000 }
sub FILE_SHARE_READ { 0x00000001 }

# dwCreationDisposition
sub CREATE_NEW { 1 }
sub CREATE_ALWAYS { 2 }
sub OPEN_EXISTING { 3 }
sub OPEN_ALWAYS { 4 }
sub TRUNCATE_EXISTING { 5 }
sub OPEN_FOR_LOADER { 6 }

# dwFlagsAndAttributes
sub FILE_ATTRIBUTE_READONLY { 0x00000001 }
sub FILE_ATTRIBUTE_HIDDEN { 0x00000002 }
sub FILE_ATTRIBUTE_SYSTEM { 0x00000004 }
sub FILE_ATTRIBUTE_1 { 0x00000008 }

sub FILE_ATTRIBUTE_DIRECTORY { 0x00000010 }
sub FILE_ATTRIBUTE_ARCHIVE { 0x00000020 }
sub FILE_ATTRIBUTE_INROM { 0x00000040 }
sub FILE_ATTRIBUTE_NORMAL { 0x00000080 }

sub FILE_ATTRIBUTE_TEMPORARY { 0x00000100 }
sub FILE_ATTRIBUTE_2 { 0x00000200 }
sub FILE_ATTRIBUTE_3 { 0x00000400 }
sub FILE_ATTRIBUTE_COMPRESSED { 0x00000800 }

sub FILE_ATTRIBUTE_ROMSTATICREF { 0x00001000 }
sub FILE_ATTRIBUTE_ROMMODULE { 0x00002000 }
sub FILE_ATTRIBUTE_4 { 0x00004000 }
sub FILE_ATTRIBUTE_5 { 0x00008000 }

sub FILE_ATTRIBUTE_HAS_CHILDREN { 0x00010000 }
sub FILE_ATTRIBUTE_SHORTCUT { 0x00020000 }
sub FILE_ATTRIBUTE_6 { 0x00040000 }
sub FILE_ATTRIBUTE_7 { 0x00080000 }

# 
# File management functions
# 
sub FAF_ATTRIBUTES { 0x00001 }
sub FAF_CREATION_TIME { 0x00002 }
sub FAF_LASTACCESS_TIME { 0x00004 }
sub FAF_LASTWRITE_TIME { 0x00008 }

sub FAF_SIZE_HIGH { 0x00010 }
sub FAF_SIZE_LOW { 0x00020 }
sub FAF_OID { 0x00040 }
sub FAF_NAME { 0x00080 }

sub FAF_ATTRIB_CHILDREN { 0x01000 }
sub FAF_ATTRIB_NO_HIDDEN { 0x02000 }
sub FAF_FOLDERS_ONLY { 0x04000 }
sub FAF_NO_HIDDEN_SYS_ROMMODULES { 0x08000 }

sub CSIDL_PROGRAMS { 0x0002 }
sub CSIDL_PERSONAL { 0x0005 }
sub CSIDL_FAVORITES_GRYPHON { 0x0006 }
sub CSIDL_STARTUP { 0x0007 }
sub CSIDL_RECENT { 0x0008 }
sub CSIDL_STARTMENU { 0x000b }
sub CSIDL_DESKTOPDIRECTORY { 0x0010 }
sub CSIDL_FONTS { 0x0014 }
sub CSIDL_FAVORITES { 0x0016 }

# 
# Database functions
# 
sub CEDB_MAXDBASENAMELEN { 32 }
sub CEDB_MAXSORTORDER { 4 }

sub CEDB_VALIDNAME { 0x0001 }
sub CEDB_VALIDTYPE { 0x0002 }
sub CEDB_VALIDSORTSPEC { 0x0004 }
sub CEDB_VALIDMODTIME { 0x0008 }

sub CEDB_AUTOINCREMENT { 0x00000001 }
sub CEDB_NOCOMPRESS { 0x00010000 }

sub CEDB_SORT_DESCENDING { 0x00000001 }
sub CEDB_SORT_CASEINSENSITIVE { 0x00000002 }
sub CEDB_SORT_UNKNOWNFIRST { 0x00000004 }
sub CEDB_SORT_GENERICORDER { 0x00000008 }

sub CEDB_SEEK_CEOID { 0x00000001 }
sub CEDB_SEEK_BEGINNING { 0x00000002 }
sub CEDB_SEEK_END { 0x00000004 }
sub CEDB_SEEK_CURRENT { 0x00000008 }

sub CEDB_SEEK_VALUESMALLER { 0x00000010 }
sub CEDB_SEEK_VALUEFIRSTEQUAL { 0x00000020 }
sub CEDB_SEEK_VALUEGREATER { 0x00000040 }
sub CEDB_SEEK_VALUENEXTEQUAL { 0x00000080 }

sub CEDB_PROPNOTFOUND { 0x0100 }
sub CEDB_PROPDELETE { 0x0200 }
sub CEDB_MAXDATABLOCKSIZE { 4092 }
sub CEDB_MAXPROPDATASIZE { CEDB_MAXDATABLOCKSIZE*16 }
sub CEDB_MAXRECORDSIZE { 128*1024 }
sub CEDB_ALLOWREALLOC { 0x00000001 }

sub CEVT_I2 { 2 }
sub CEVT_I4 { 3 }
sub CEVT_R8 { 5 }
sub CEVT_BOOL { 11 }
sub CEVT_UI2 { 18 }
sub CEVT_UI4 { 19 }
sub CEVT_LPWSTR { 31 }
sub CEVT_FILETIME { 64 }
sub CEVT_BLOB { 65 }

# Undocumented flag used by synchronization to denote an empty field
sub CEVT_FLAG_EMPTY { 0x0400 }

sub FAD_OID { 0x0001 }
sub FAD_FLAGS { 0x0002 }
sub FAD_NAME { 0x0004 }
sub FAD_TYPE { 0x0008 }

sub FAD_NUM_RECORDS { 0x0010 }
sub FAD_NUM_SORT_ORDER { 0x0020 }
sub FAD_SIZE { 0x0040 }
sub FAD_LAST_MODIFIED { 0x0080 }

sub FAD_SORT_SPECS { 0x0100 }

#
# Registry
#
sub HKEY_CLASSES_ROOT { 0x80000000 }
sub HKEY_CURRENT_USER { 0x80000001 }
sub HKEY_LOCAL_MACHINE { 0x80000002 }
sub HKEY_USERS { 0x80000003 }

sub REG_NONE { 0 }
sub REG_SZ { 1 }
sub REG_EXPAND_SZ { 2 }
sub REG_BINARY { 3 }
sub REG_DWORD { 4 }
sub REG_DWORD_LITTLE_ENDIAN { 4 }
sub REG_DWORD_BIG_ENDIAN { 5 }
sub REG_LINK { 6 }
sub REG_MULTI_SZ { 7 }

#
# Misc functions
#
sub PROCESSOR_INTEL_386 { 386 }
sub PROCESSOR_INTEL_486 { 486 }
sub PROCESSOR_INTEL_PENTIUM { 586 }
sub PROCESSOR_INTEL_PENTIUMII { 686 }
sub PROCESSOR_MIPS_R4000 { 4000 }
sub PROCESSOR_ALPHA_21064 { 21064 }
sub PROCESSOR_PPC_403 { 403 }
sub PROCESSOR_PPC_601 { 601 }
sub PROCESSOR_PPC_603 { 603 }
sub PROCESSOR_PPC_604 { 604 }
sub PROCESSOR_PPC_620 { 620 }
sub PROCESSOR_HITACHI_SH3 { 10003 }
sub PROCESSOR_HITACHI_SH3E { 10004 }
sub PROCESSOR_HITACHI_SH4 { 10005 }
sub PROCESSOR_MOTOROLA_821 { 821 }
sub PROCESSOR_SHx_SH3 { 103 }
sub PROCESSOR_SHx_SH4 { 104 }
sub PROCESSOR_STRONGARM { 2577 }
sub PROCESSOR_ARM720 { 1824 }
sub PROCESSOR_ARM820 { 2080 }
sub PROCESSOR_ARM920 { 23360 }
sub PROCESSOR_ARM_7TDMI { 70001 }

sub PROCESSOR_ARCHITECTURE_INTEL { 0 }
sub PROCESSOR_ARCHITECTURE_MIPS { 1 }
sub PROCESSOR_ARCHITECTURE_ALPHA { 2 }
sub PROCESSOR_ARCHITECTURE_PPC { 3 }
sub PROCESSOR_ARCHITECTURE_SHX { 4 }
sub PROCESSOR_ARCHITECTURE_ARM { 5 }
sub PROCESSOR_ARCHITECTURE_IA64 { 6 }
sub PROCESSOR_ARCHITECTURE_ALPHA64 { 7 }
sub PROCESSOR_ARCHITECTURE_UNKNOWN { 0xFFFF }

sub AC_LINE_OFFLINE { 0x00 }
sub AC_LINE_ONLINE { 0x01 }
sub AC_LINE_BACKUP_POWER { 0x02 }
sub AC_LINE_UNKNOWN { 0xFF }

sub BATTERY_FLAG_HIGH { 0x01 }
sub BATTERY_FLAG_LOW { 0x02 }
sub BATTERY_FLAG_CRITICAL { 0x04 }
sub BATTERY_FLAG_CHARGING { 0x08 }
sub BATTERY_FLAG_NO_BATTERY { 0x80 }
sub BATTERY_FLAG_UNKNOWN { 0xFF }

sub BATTERY_PERCENTAGE_UNKNOWN { 0xFF }

sub BATTERY_LIFE_UNKNOWN { 0xFFFFFFFF }

sub VER_PLATFORM_WIN32s { 0 }
sub VER_PLATFORM_WIN32_WINDOWS { 1 }
sub VER_PLATFORM_WIN32_NT { 2 }
sub VER_PLATFORM_WIN32_HH { 3 }
sub VER_PLATFORM_WIN32_CE { 3 }

sub OBJTYPE_INVALID { 0 }
sub OBJTYPE_FILE { 1 }
sub OBJTYPE_DIRECTORY { 2 }
sub OBJTYPE_DATABASE { 3 }
sub OBJTYPE_RECORD { 4 }
#
# returned by CeOidGetInfo() for an ActiveSync notification when
# an object has been deleted.
#
sub OBJTYPE_DELETED { 8 }


# ID's for the Contacts Database
# NOTE: This comes not from the rapi.
sub CE_TITLE { 0x3A05 }
sub CE_FIRST_NAME { 0x3A06 }
sub CE_TEL_OFFICE { 0x3A08 }
sub CE_TEL_PRIVAT { 0x3A09 }
sub CE_LAST_NAME { 0x3A11 }
sub CE_COMPANY { 0x3A16 }
sub CE_POSITION	{ 0x3A17 }
sub CE_DEPART { 0x3A18 }
sub CE_OFFICE { 0x3A19 }
sub CE_TEL_MOBIL { 0x3A1C }
sub CE_TEL_RADIO { 0x3A1D }
sub CE_TEL_CAR { 0x3A1E }
sub CE_FAX_OFFICE { 0x3A24 }
sub CE_FAX_PRIVAT { 0x3A25 }
sub CE_TEL_PRIVAT2 { 0x3A2F }
sub CE_BIRTHDAY	{ 0x4001 }
sub CE_SEKRET { 0x4002 }
sub CE_ANNYVERSARY { 0x4003 }
sub CE_TEL_SEKRET { 0x4004 }
sub CE_CHILDREN	{ 0x4006 }
sub CE_TEL_OFFICE2 { 0x4007 }
sub CE_WEBPAGE { 0x4008 }
sub CE_PAGER { 0x4009 }
sub CE_MATE { 0x400A }
sub CE_LAST_FIRST_NAME { 0x4013 }
sub CE_SALUTATION { 0x4023 }
sub CE_SEC_NAME	{ 0x4024 }

sub CE_PRIVAT_STREET { 0x4040 }
sub CE_PRIVAT_CITY { 0x4041 }
sub CE_PRIVAT_REGION { 0x4042 }
sub CE_PRIVAT_ZIP { 0x4043 }
sub CE_PRIVAT_COUNTRY { 0x4044 }

sub CE_OFFICE_STREET { 0x4045 }
sub CE_OFFICE_CITY { 0x4046 }
sub CE_OFFICE_REGION { 0x4047 }
sub CE_OFFICE_ZIP { 0x4048 }
sub CE_OFFICE_COUNTRY { 0x4049 }

sub CE_ADD_STREET { 0x404A }
sub CE_ADD_CITY	{ 0x404B }
sub CE_ADD_REGION { 0x404C }
sub CE_ADD_ZIP { 0x404D }
sub CE_ADD_COUNTRY { 0x404E }

sub CE_EMAIL { 0x4083 }
sub CE_EMAIL2 { 0x4093 }
sub CE_EMAIL3 { 0x40A3 }

sub CE_CATEGORY	{ 0x0016 }
sub CE_NOTE { 0x0017 }

sub CE_CATPRIV { 0x1000 }
sub CE_CATWORK { 0x0001 }


#
# Defines from rapi_types.h
#

#
# Some error codes (HRESULTs)
#

sub E_ABORT { 0x80004004 }
sub E_ACCESSDENIED { 0x80070005 }
sub E_FAIL { 0x80004005 }
sub E_HANDLE { 0x80070006 }
sub E_INVALIDARG { 0x80070057 }
sub E_NOINTERFACE { 0x80004002 }
sub E_NOTIMPL { 0x80004001 }
sub E_OUTOFMEMORY { 0x8007000E }
sub E_PENDING { 0x8000000A }
sub E_POINTER { 0x80004003 }
sub E_UNEXPECTED { 0x8000FFFF }
sub S_FALSE { 0x00000001 }
sub S_OK { 0x00000000 }

#
# Error codes for registry functions
#

sub ERROR_SUCCESS { 0 }
sub ERROR_FILE_NOT_FOUND { 2 }
sub ERROR_NOT_ENOUGH_MEMORY { 8 }
sub ERROR_SEEK {  25 }
sub ERROR_INVALID_PARAMETER { 87 }
sub ERROR_INSUFFICIENT_BUFFER { 122 }
sub ERROR_NO_DATA { 232 }
sub ERROR_NO_MORE_ITEMS { 259 }
sub ERROR_KEY_DELETED { 1018 }

#
# Other macros
#

sub MAX_PATH { 256 }

1;

__END__

=head1 NAME

Rapi2::Defs - Defines from the rapi.h and the rapi_types.h

=head1 SYNOPSIS

  use Rapi2::Defs;

=head1 VALUES

  #
  # File access functions
  #

  # dwShareMode
  GENERIC_WRITE = 0x40000000
  GENERIC_READ = 0x80000000
  FILE_SHARE_READ = 0x00000001

  # dwCreationDisposition
  CREATE_NEW = 1
  CREATE_ALWAYS = 2
  OPEN_EXISTING = 3
  OPEN_ALWAYS = 4
  TRUNCATE_EXISTING = 5
  OPEN_FOR_LOADER = 6

  # dwFlagsAndAttributes
  FILE_ATTRIBUTE_READONLY = 0x00000001
  FILE_ATTRIBUTE_HIDDEN = 0x00000002
  FILE_ATTRIBUTE_SYSTEM = 0x00000004
  FILE_ATTRIBUTE_1 = 0x00000008

  FILE_ATTRIBUTE_DIRECTORY = 0x00000010
  FILE_ATTRIBUTE_ARCHIVE = 0x00000020
  FILE_ATTRIBUTE_INROM = 0x00000040
  FILE_ATTRIBUTE_NORMAL = 0x00000080

  FILE_ATTRIBUTE_TEMPORARY = 0x00000100
  FILE_ATTRIBUTE_2 = 0x00000200
  FILE_ATTRIBUTE_3 = 0x00000400
  FILE_ATTRIBUTE_COMPRESSED = 0x00000800

  FILE_ATTRIBUTE_ROMSTATICREF = 0x00001000
  FILE_ATTRIBUTE_ROMMODULE = 0x00002000
  FILE_ATTRIBUTE_4 = 0x00004000
  FILE_ATTRIBUTE_5 = 0x00008000

  FILE_ATTRIBUTE_HAS_CHILDREN = 0x00010000
  FILE_ATTRIBUTE_SHORTCUT = 0x00020000
  FILE_ATTRIBUTE_6 = 0x00040000
  FILE_ATTRIBUTE_7 = 0x00080000

  #
  # File management functions
  #
  FAF_ATTRIBUTES = 0x00001
  FAF_CREATION_TIME = 0x00002
  FAF_LASTACCESS_TIME = 0x00004
  FAF_LASTWRITE_TIME = 0x00008

  FAF_SIZE_HIGH = 0x00010
  FAF_SIZE_LOW = 0x00020
  FAF_OID = 0x00040
  FAF_NAME = 0x00080

  FAF_ATTRIB_CHILDREN = 0x01000
  FAF_ATTRIB_NO_HIDDEN = 0x02000
  FAF_FOLDERS_ONLY = 0x04000
  FAF_NO_HIDDEN_SYS_ROMMODULES = 0x08000

  CSIDL_PROGRAMS = 0x0002
  CSIDL_PERSONAL = 0x0005
  CSIDL_FAVORITES_GRYPHON = 0x0006
  CSIDL_STARTUP = 0x0007
  CSIDL_RECENT = 0x0008
  CSIDL_STARTMENU = 0x000b
  CSIDL_DESKTOPDIRECTORY = 0x0010
  CSIDL_FONTS = 0x0014
  CSIDL_FAVORITES = 0x0016

  #
  # Database functions
  #
  CEDB_MAXDBASENAMELEN = 32
  CEDB_MAXSORTORDER = 4

  CEDB_VALIDNAME = 0x0001
  CEDB_VALIDTYPE = 0x0002
  CEDB_VALIDSORTSPEC = 0x0004
  CEDB_VALIDMODTIME = 0x0008

  CEDB_AUTOINCREMENT = 0x00000001
  CEDB_NOCOMPRESS = 0x00010000

  CEDB_SORT_DESCENDING = 0x00000001
  CEDB_SORT_CASEINSENSITIVE = 0x00000002
  CEDB_SORT_UNKNOWNFIRST = 0x00000004
  CEDB_SORT_GENERICORDER = 0x00000008

  CEDB_SEEK_CEOID = 0x00000001
  CEDB_SEEK_BEGINNING = 0x00000002
  CEDB_SEEK_END = 0x00000004
  CEDB_SEEK_CURRENT = 0x00000008

  CEDB_SEEK_VALUESMALLER = 0x00000010
  CEDB_SEEK_VALUEFIRSTEQUAL = 0x00000020
  CEDB_SEEK_VALUEGREATER = 0x00000040
  CEDB_SEEK_VALUENEXTEQUAL = 0x00000080

  CEDB_PROPNOTFOUND = 0x0100
  CEDB_PROPDELETE = 0x0200
  CEDB_MAXDATABLOCKSIZE = 4092
  CEDB_MAXPROPDATASIZE = CEDB_MAXDATABLOCKSIZE*16
  CEDB_MAXRECORDSIZE = 128*1024
  CEDB_ALLOWREALLOC = 0x00000001

  CEVT_I2 = 2
  CEVT_I4 = 3
  CEVT_R8 = 5
  CEVT_BOOL = 11
  CEVT_UI2 = 18
  CEVT_UI4 = 19
  CEVT_LPWSTR = 31
  CEVT_FILETIME = 64
  CEVT_BLOB = 65

  # Undocumented flag used by synchronization to denote an empty field
  CEVT_FLAG_EMPTY = 0x0400

  FAD_OID = 0x0001
  FAD_FLAGS = 0x0002
  FAD_NAME = 0x0004
  FAD_TYPE = 0x0008

  FAD_NUM_RECORDS = 0x0010
  FAD_NUM_SORT_ORDER = 0x0020
  FAD_SIZE = 0x0040
  FAD_LAST_MODIFIED = 0x0080

  FAD_SORT_SPECS = 0x0100

  #
  # Registry
  #
  HKEY_CLASSES_ROOT = 0x80000000
  HKEY_CURRENT_USER = 0x80000001
  HKEY_LOCAL_MACHINE = 0x80000002
  HKEY_USERS = 0x80000003

  REG_NONE = 0
  REG_SZ = 1
  REG_EXPAND_SZ = 2
  REG_BINARY = 3
  REG_DWORD = 4
  REG_DWORD_LITTLE_ENDIAN = 4
  REG_DWORD_BIG_ENDIAN = 5
  REG_LINK = 6
  REG_MULTI_SZ = 7

  #
  # Misc functions
  #
  PROCESSOR_INTEL_386 = 386
  PROCESSOR_INTEL_486 = 486
  PROCESSOR_INTEL_PENTIUM = 586
  PROCESSOR_INTEL_PENTIUMII = 686
  PROCESSOR_MIPS_R4000 = 4000
  PROCESSOR_ALPHA_21064 = 21064
  PROCESSOR_PPC_403 = 403
  PROCESSOR_PPC_601 = 601
  PROCESSOR_PPC_603 = 603
  PROCESSOR_PPC_604 = 604
  PROCESSOR_PPC_620 = 620
  PROCESSOR_HITACHI_SH3 = 10003
  PROCESSOR_HITACHI_SH3E = 10004
  PROCESSOR_HITACHI_SH4 = 10005
  PROCESSOR_MOTOROLA_821 = 821
  PROCESSOR_SHx_SH3 = 103
  PROCESSOR_SHx_SH4 = 104
  PROCESSOR_STRONGARM = 2577
  PROCESSOR_ARM720 = 1824
  PROCESSOR_ARM820 = 2080
  PROCESSOR_ARM920 = 23360
  PROCESSOR_ARM_7TDMI = 70001

  PROCESSOR_ARCHITECTURE_INTEL = 0
  PROCESSOR_ARCHITECTURE_MIPS = 1
  PROCESSOR_ARCHITECTURE_ALPHA = 2
  PROCESSOR_ARCHITECTURE_PPC = 3
  PROCESSOR_ARCHITECTURE_SHX = 4
  PROCESSOR_ARCHITECTURE_ARM = 5
  PROCESSOR_ARCHITECTURE_IA64 = 6
  PROCESSOR_ARCHITECTURE_ALPHA64 = 7
  PROCESSOR_ARCHITECTURE_UNKNOWN = 0xFFFF

  AC_LINE_OFFLINE = 0x00
  AC_LINE_ONLINE = 0x01
  AC_LINE_BACKUP_POWER = 0x02
  AC_LINE_UNKNOWN = 0xFF

  BATTERY_FLAG_HIGH = 0x01
  BATTERY_FLAG_LOW = 0x02
  BATTERY_FLAG_CRITICAL = 0x04
  BATTERY_FLAG_CHARGING = 0x08
  BATTERY_FLAG_NO_BATTERY = 0x80
  BATTERY_FLAG_UNKNOWN = 0xFF

  BATTERY_PERCENTAGE_UNKNOWN = 0xFF

  BATTERY_LIFE_UNKNOWN = 0xFFFFFFFF

  VER_PLATFORM_WIN32s = 0
  VER_PLATFORM_WIN32_WINDOWS = 1
  VER_PLATFORM_WIN32_NT = 2
  VER_PLATFORM_WIN32_HH = 3
  VER_PLATFORM_WIN32_CE = 3

  OBJTYPE_INVALID = 0
  OBJTYPE_FILE = 1
  OBJTYPE_DIRECTORY = 2
  OBJTYPE_DATABASE = 3
  OBJTYPE_RECORD = 4
  #
  # returned by CeOidGetInfo() for an ActiveSync notification when
  # an object has been deleted.
  #
  OBJTYPE_DELETED = 8


  # ID's for the Contacts Database
  # NOTE: This comes not from the rapi.
  CE_TITLE = 0x3A05
  CE_FIRST_NAME = 0x3A06
  CE_TEL_OFFICE = 0x3A08
  CE_TEL_PRIVAT = 0x3A09
  CE_LAST_NAME = 0x3A11
  CE_COMPANY = 0x3A16
  CE_POSITION = 0x3A17
  CE_DEPART = 0x3A18
  CE_OFFICE = 0x3A19
  CE_TEL_MOBIL = 0x3A1C
  CE_TEL_RADIO = 0x3A1D
  CE_TEL_CAR = 0x3A1E
  CE_FAX_OFFICE = 0x3A24
  CE_FAX_PRIVAT = 0x3A25
  CE_TEL_PRIVAT2 = 0x3A2F
  CE_BIRTHDAY = 0x4001
  CE_SEKRET = 0x4002
  CE_ANNYVERSARY = 0x4003
  CE_TEL_SEKRET = 0x4004
  CE_CHILDREN = 0x4006
  CE_TEL_OFFICE2 = 0x4007
  CE_WEBPAGE = 0x4008
  CE_PAGER = 0x4009
  CE_MATE = 0x400A
  CE_LAST_FIRST_NAME = 0x4013
  CE_SALUTATION = 0x4023
  CE_SEC_NAME = 0x4024

  CE_PRIVAT_STREET = 0x4040
  CE_PRIVAT_CITY = 0x4041
  CE_PRIVAT_REGION = 0x4042
  CE_PRIVAT_ZIP = 0x4043
  CE_PRIVAT_COUNTRY = 0x4044

  CE_OFFICE_STREET = 0x4045
  CE_OFFICE_CITY = 0x4046
  CE_OFFICE_REGION = 0x4047
  CE_OFFICE_ZIP = 0x4048
  CE_OFFICE_COUNTRY = 0x4049

  CE_ADD_STREET = 0x404A
  CE_ADD_CITY = 0x404B
  CE_ADD_REGION = 0x404C
  CE_ADD_ZIP = 0x404D
  CE_ADD_COUNTRY = 0x404E

  CE_EMAIL = 0x4083
  CE_EMAIL2 = 0x4093
  CE_EMAIL3 = 0x40A3

  CE_CATEGORY = 0x0016
  CE_NOTE = 0x0017

  CE_CATPRIV = 0x1000
  CE_CATWORK = 0x0001


  #
  # Defines from rapi_types.h
  #

  #
  # Some error codes (HRESULTs)
  #

  E_ABORT = 0x80004004
  E_ACCESSDENIED = 0x80070005
  E_FAIL = 0x80004005
  E_HANDLE = 0x80070006
  E_INVALIDARG = 0x80070057
  E_NOINTERFACE = 0x80004002
  E_NOTIMPL = 0x80004001
  E_OUTOFMEMORY = 0x8007000E
  E_PENDING = 0x8000000A
  E_POINTER = 0x80004003
  E_UNEXPECTED = 0x8000FFFF
  S_FALSE = 0x00000001
  S_OK = 0x00000000

  #
  # Error codes for registry functions
  #

  ERROR_SUCCESS = 0
  ERROR_FILE_NOT_FOUND = 2
  ERROR_NOT_ENOUGH_MEMORY = 8
  ERROR_SEEK =  25
  ERROR_INVALID_PARAMETER = 87
  ERROR_INSUFFICIENT_BUFFER = 122
  ERROR_NO_DATA = 232
  ERROR_NO_MORE_ITEMS = 259
  ERROR_KEY_DELETED = 1018

  #
  # Other macros
  #

  MAX_PATH = 256

=head1 AUTHOR

Andreas Pohl (osar@users.sourceforge.net)

=cut
